VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsBpca"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' == Caution for use! ==
'
' When you copy a class module in workbook,
' please perform it by Export & Import from Bpca_Class_V20E.xls by all means.
' (The export file of the class module prepares in the distribution file.)
' If you perform it by Copy & Paste between code windows of VBE,
' Enter/Exit/BeforeUpdate/AfterUpdate and Default-property (Item) do not work.

'_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
'_/
'_/ [ clsBpca ] Ver 4.0
'_/
'_/   --- Breakthrough in the Pseudo-Control-Array --- (Excel2000 or later)
'_/
'_/     Control: Label, CommandButton, TextBox, CheckBox
'_/              OptionButton, ToggleButton, ComboBox, SpinButton
'_/
'_/     Event  : Enter, Exit, BeforeUpdate, AfterUpdate
'_/              Change, Click, DblClick, KeyDown, KeyPress, KeyUp
'_/              SpinDown, SpinUp, DropButtonClick
'_/              MouseMove, MouseDown, MouseUp , (FakeExit)
'_/
'_/     AddinBox(K.Tsunoda) CopyRight(C) 2004 Allrights Reserved.
'_/       [http://addinbox.sakura.ne.jp/Breakthrough_P-Ctrl_Arrays_Eng.htm ]
'_/       [Old Site : http://www.h3.dion.ne.jp/~sakatsu/Breakthrough_P-Ctrl_Arrays_Eng.htm ]
'_/
'_/     ----- Japanese version ----
'_/     22 Jun 2004 Ver1.0  1st version
'_/     23 Jun 2004 Ver1.1
'_/     10 Mar 2005 Ver1.2
'_/     15 Apr 2011 Ver1.3
'_/     22 Jul 2014 Ver1.4
'_/     11 Aug 2014 Ver2.0  Enter/Exit/BeforeUpdate/AfterUpdate are supported.
'_/     10 Oct 2016 Ver3.0  FakeExit event & InitFColor/InitBColor properties are added.
'_/     13 Oct 2016 Ver3.1  Correction of the malfunction (When Frame/MultiPage
'_/                         does not have ActiveControl (ActiveControl=Nothing),
'_/                         it becomes the error by FakeExit processing.)
'_/     (Ver3.2 - Ver3.4)   Replace "Japan Holiday module" for Calendar form.
'_/      1 Sep 2020 Ver4.0  Fixed a bug that a runtime error occurs when controls on a worksheet are specified.
'_/
'_/     ----- English version ----
'_/     24 Jul 2014 Ver1.4  1st version
'_/     11 Aug 2014 Ver2.0  Enter/Exit/BeforeUpdate/AfterUpdate are supported.
'_/     10 Oct 2016 Ver3.0  FakeExit event & InitFColor/InitBColor properties are added.
'_/     13 Oct 2016 Ver3.1  Correction of the malfunction (When Frame/MultiPage
'_/                         does not have ActiveControl (ActiveControl=Nothing),
'_/                         it becomes the error by FakeExit processing.)
'_/      1 Sep 2020 Ver4.0  Fixed a bug that a runtime error occurs when controls on a worksheet are specified.
'_/
'_/  [clsBpcaCh / modBpcaConst] module is necessary together.
'_/  It works in x64.
'_/
'_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

'(1) The event that you do not appoint by "Rgst method" does not occur
'    even if you prepare the Event-Procedure on the user side.

'(2) If the user side does not have the Event-Procedure, the event does
'    not happen even if you appoint it by "Rgst method".

'(3) The event that the control does not possess does not occur even
'    if you appoint it by "Rgst method".

'-----[ Event definition ]-----------------------------------------------
Public Event Change(ByVal Index As Integer)
Public Event Click(ByVal Index As Integer)
Public Event DblClick(ByVal Index As Integer, ByVal Cancel As MSForms.ReturnBoolean)
Public Event KeyDown(ByVal Index As Integer, ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
Public Event KeyPress(ByVal Index As Integer, ByVal KeyAscii As MSForms.ReturnInteger)
Public Event KeyUp(ByVal Index As Integer, ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
Public Event MouseMove(ByVal Index As Integer, ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
Public Event MouseDown(ByVal Index As Integer, ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
Public Event MouseUp(ByVal Index As Integer, ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
Public Event DropButtonClick(ByVal Index As Integer)
Public Event SpinDown(ByVal Index As Integer)
Public Event SpinUp(ByVal Index As Integer)


'Because Enter/Exit/BeforeUpdate/AfterUpdate are events of MsForm.Control
'(it cannot treat in the class module), we hook those events by ConnectToConnectionPoint.
'Because the name of "Exit event" and "Exit statement" collide,
'I add "On" to the head of the name of the Enter/Exit event.
Public Event OnEnter(ByVal Index As Integer)
Public Event OnExit(ByVal Index As Integer, ByVal Cancel As MSForms.ReturnBoolean)
Public Event AfterUpdate(ByVal Index As Integer)
Public Event BeforeUpdate(ByVal Index As Integer, ByVal Cancel As MSForms.ReturnBoolean)

'An event to improve the issue that Exit event does not fire
'at the time of Frame/MutiPage escape.
'It detect Exit event of Frame/MultiPage and Change event of MultiPage.
'And it fire FakeExit event for ActiveControl at that time.
Public Event FakeExit(ByVal Index As Integer)

'------------------------------------------------------------------
Private clsBpcaCtrlCh() As clsBpcaCh    'Child class
Private colBpcaCtrlGrp As Collection    'Storage collection of Controls

Private clsBpcaContainerCh() As clsBpcaCh   'Child class (for Frame/MultiPage)
Private colBpcaContainerGrp As Collection   'Storage collection of Controls (for Frame/MultiPage)

Private MyTypeName As String
Private blnAllType As Boolean
Private blnRgst As Boolean      'Registration flag


'==============================================================
Private Sub Class_Initialize()
    Set colBpcaCtrlGrp = New Collection
    Set colBpcaContainerGrp = New Collection
    blnRgst = False
    blnAllType = False
    MyTypeName = ""
End Sub

'==================================================================
Private Sub Class_Terminate()
    If (blnRgst = True) Or (Not (colBpcaCtrlGrp Is Nothing)) Then
        Me.Clear
    End If
End Sub

'======== Property / Method definition =============================

'---( Add method )------------------------------------------------
'Add control to become array to collection.
Public Sub Add(ByVal NewCtrl As Object)
    If (blnRgst = False) Then
        Select Case TypeName(NewCtrl)
            Case "Label", "CommandButton", "TextBox", "CheckBox", _
                 "OptionButton", "ToggleButton", "ComboBox", "SpinButton"
                'Add to Collection
                colBpcaCtrlGrp.Add NewCtrl
            Case Else
                'do not add the non-supported control
        End Select
    Else
        'Because Rgst method is executed, I do not add it.
    End If
End Sub

'---( Rgst method )------------------------------------------------
'I set the control that enrolled in collection in the array of the clsBpcaCh class.
'I receive the classification of the event to produce by an argument.
Public Sub Rgst(ByVal NewEvent As BPCA_Event, Optional ByVal AllType As Boolean = False)
Dim i As Integer
Dim blnERR As Boolean
    If (blnRgst = True) Then
        'Because Rgst method is executed, I do not handle it.
        Exit Sub
    ElseIf (colBpcaCtrlGrp.Count = 0) Then
        blnRgst = False
        Exit Sub
    Else
    End If
    
    blnAllType = AllType
    blnERR = False
        
    'In the case of "AllType=False", The control after the second
    'is the same as a type of the top control.
    MyTypeName = TypeName(colBpcaCtrlGrp(1))
    For i = 2 To colBpcaCtrlGrp.Count
        If (MyTypeName <> TypeName(colBpcaCtrlGrp(i))) Then
            If (blnAllType = False) Then
                blnERR = True
            End If
        End If
    Next i
    If (blnERR = True) Then
        Exit Sub
    End If
    
    ReDim clsBpcaCtrlCh(1 To colBpcaCtrlGrp.Count)
    For i = 1 To colBpcaCtrlGrp.Count
        Set clsBpcaCtrlCh(i) = New clsBpcaCh
        With clsBpcaCtrlCh(i)
            'It perform [EventSet] first to judge necessity or not
            'of [ConnectToConnectionPoint].
            .EventSet = NewEvent
            .Item = colBpcaCtrlGrp(i)
            .Index = i
            .Parent = Me
        End With
      
      Call prvContainerCheck(colBpcaCtrlGrp(i))
    Next i
    blnRgst = True

    If (colBpcaContainerGrp.Count = 0) Then
        Exit Sub
    ElseIf ((NewEvent And BPCA2_FakeExit) = BPCA2_FakeExit) Then
        ReDim clsBpcaContainerCh(1 To colBpcaContainerGrp.Count)
        For i = 1 To colBpcaContainerGrp.Count
          Set clsBpcaContainerCh(i) = New clsBpcaCh
          With clsBpcaContainerCh(i)
              'It perform [EventSet] first to judge necessity or not
              'of [ConnectToConnectionPoint].
              .EventSet = BPCA_Exit + BPCA_Change
              .Item = colBpcaContainerGrp(i)
              .Index = i
              .Parent = Me
          End With
    Next i
    Else
        'No designation of FakeExit
    End If
End Sub

Private Sub prvContainerCheck(ByRef Ctrl As Object)
Dim j As Integer
Dim ParentCtrl As Object
Dim blnCheck As Boolean
Dim ParentType As String
    
    ' -- Fixed a bug in Ver4.0 --
    ' For controls on the worksheet, the control specifications are as follows.
    '   [ Worksheet obeject .OLEObjects(Control Name).Object ]
    ' However, since there is no Parent property in Object, a runtime error occurs (Ver3.0-3.1).
    ' In addition, OLEObjects(Control Name) has a Parent property.
    On Error Resume Next
    ParentType = ""
    ParentType = TypeName(Ctrl.Parent)
    On Error GoTo 0
    
    'Select Case TypeName(Ctrl.Parent)   '(Ver3.0-3.1) Corrected in Ver4.0 (added the above processing)
    Select Case ParentType
      Case "Frame"
        Set ParentCtrl = Ctrl.Parent
      Case "Page"
        'The parent of the controls in MultiPage is Page.
        'The parent of Page is MultiPage.
        Set ParentCtrl = Ctrl.Parent.Parent
      Case Else
        'Blank for controls on worksheet
        Exit Sub
    End Select
    
    If (colBpcaContainerGrp.Count = 0) Then
        colBpcaContainerGrp.Add ParentCtrl
    Else
        blnCheck = False
        For j = 1 To colBpcaContainerGrp.Count
            If (colBpcaContainerGrp(j) Is ParentCtrl) Then
                blnCheck = True
                Exit For
            End If
        Next j
        If (blnCheck = False) Then
            colBpcaContainerGrp.Add ParentCtrl
        End If
    End If

    Set ParentCtrl = Nothing
End Sub

'---( Clear method )-----------------------------
Public Sub Clear()
Dim i As Integer
Dim j As Integer

    If (blnRgst = True) Then
        For i = 1 To colBpcaCtrlGrp.Count
            clsBpcaCtrlCh(i).Clear
        Next i
        
        On Error Resume Next
        j = -1
        j = LBound(clsBpcaContainerCh)
        On Error GoTo 0
        For i = 1 To j
            clsBpcaContainerCh(i).Clear
        Next i
    End If
    
    Set colBpcaCtrlGrp = Nothing
    Erase clsBpcaCtrlCh

    Set colBpcaContainerGrp = Nothing
    Erase clsBpcaContainerCh

    blnRgst = False
End Sub

'---( Count property )---------------------------------------------
Public Property Get Count() As Integer
    Count = colBpcaCtrlGrp.Count
End Property

'---( getIndex property )---------------------------------------------
'It returns a value of "Index" becoming necessary for each property from a control name.
'In the case of a non-registration name, it returns -1.
Public Property Get getIndex(ByVal CtrlName As String) As Integer
Dim i As Integer
    getIndex = -1
    If (blnRgst = True) Then
        For i = 1 To colBpcaCtrlGrp.Count
            If (colBpcaCtrlGrp(i).Name = CtrlName) Then
                getIndex = i
                Exit For
            End If
        Next i
    Else
    End If
End Property

'---( EnableEvents property )----------------------------------------
Public Property Let EnableEvents(ByVal Index As Integer, ByVal NewEnableEvents As Boolean)
    If (blnRgst = True) And _
       (Index > 0) And (Index <= colBpcaCtrlGrp.Count) Then
        clsBpcaCtrlCh(Index).EnableEvents = NewEnableEvents
    Else
    End If
End Property

Public Property Get EnableEvents(ByVal Index As Integer) As Boolean
    If (blnRgst = True) And _
       (Index > 0) And (Index <= colBpcaCtrlGrp.Count) Then
        EnableEvents = clsBpcaCtrlCh(Index).EnableEvents
    Else
        EnableEvents = False
    End If
End Property

'---( EventState property )--------------------------------------------
' I return Variant array for the event raise classification
' that I received in EventSet property.
'  0: Long type, 1-17: Boolean type
'
'  [0] The numerical value that I received in EventSet
'  [1] Change, [2] Click, [3] DblClick
'  [4] KeyDown, [5] KeyPress, [6] KeyUp
'  [7] MouseMove, [8] MouseDown, [9] MouseUp
'  [10] DropBtnClick, [11] SpinDown, [12] SpinUp
'  [13] Enter, [14] Exit, [15] BeforeUpdate, [16] AfterUpdate
'  [17] FakeExit
Public Property Get EventState() As Variant
    If (blnRgst = True) Then
        EventState = clsBpcaCtrlCh(1).EventState
    Else
        EventState = Empty
    End If
End Property

'---( Item property : Default property)----------------------------
'I return individual control objects from the control array.

Public Property Get Item(ByVal Index As Integer) As Object
Attribute Item.VB_UserMemId = 0
'Attribute Item.VB_UserMemId = 0

'(Note)
'The Item property becomes the Default property.
'The statement("Attribute Item.VB_UserMemId = 0") mentioned above is added
'to this part of the class module to assume it the Default property
'(you do not watch it from a code window).
'If you watch the export file (clsBpca.cls) of this class module, you can confirm it.

    If (blnRgst = True) And _
       (Index > 0) And (Index <= colBpcaCtrlGrp.Count) Then
        Set Item = colBpcaCtrlGrp(Index)
    Else
        Set Item = Nothing
    End If
End Property

'---( ItmXXX property )-------------------------------------------
'I return individual control objects from the control array.
'I return MsForms type to a type of the control.
Public Property Get ItmLbl(ByVal Index As Integer) As MSForms.Label
Dim strTypeName As String
    If (blnRgst = True) And _
       (Index > 0) And (Index <= colBpcaCtrlGrp.Count) Then
        If (blnAllType = False) Then
            strTypeName = MyTypeName
        Else
            strTypeName = TypeName(colBpcaCtrlGrp(Index))
        End If
        If (strTypeName = "Label") Then
                Set ItmLbl = colBpcaCtrlGrp(Index)
        Else
            Set ItmLbl = Nothing
        End If
    Else
        Set ItmLbl = Nothing
    End If
End Property

Public Property Get ItmCmd(ByVal Index As Integer) As MSForms.CommandButton
Dim strTypeName As String
    If (blnRgst = True) And _
       (Index > 0) And (Index <= colBpcaCtrlGrp.Count) Then
        If (blnAllType = False) Then
            strTypeName = MyTypeName
        Else
            strTypeName = TypeName(colBpcaCtrlGrp(Index))
        End If
        If (strTypeName = "CommandButton") Then
            Set ItmCmd = colBpcaCtrlGrp(Index)
        Else
            Set ItmCmd = Nothing
        End If
    Else
        Set ItmCmd = Nothing
    End If
End Property

Public Property Get ItmTxt(ByVal Index As Integer) As MSForms.TextBox
Dim strTypeName As String
    If (blnRgst = True) And _
       (Index > 0) And (Index <= colBpcaCtrlGrp.Count) Then
        If (blnAllType = False) Then
            strTypeName = MyTypeName
        Else
            strTypeName = TypeName(colBpcaCtrlGrp(Index))
        End If
        If (strTypeName = "TextBox") Then
            Set ItmTxt = colBpcaCtrlGrp(Index)
        Else
            Set ItmTxt = Nothing
        End If
    Else
        Set ItmTxt = Nothing
    End If
End Property

Public Property Get ItmChk(ByVal Index As Integer) As MSForms.CheckBox
Dim strTypeName As String
    If (blnRgst = True) And _
       (Index > 0) And (Index <= colBpcaCtrlGrp.Count) Then
        If (blnAllType = False) Then
            strTypeName = MyTypeName
        Else
            strTypeName = TypeName(colBpcaCtrlGrp(Index))
        End If
        If (strTypeName = "CheckBox") Then
            Set ItmChk = colBpcaCtrlGrp(Index)
        Else
            Set ItmChk = Nothing
        End If
    Else
        Set ItmChk = Nothing
    End If
End Property

Public Property Get ItmOpt(ByVal Index As Integer) As MSForms.OptionButton
Dim strTypeName As String
    If (blnRgst = True) And _
       (Index > 0) And (Index <= colBpcaCtrlGrp.Count) Then
        If (blnAllType = False) Then
            strTypeName = MyTypeName
        Else
            strTypeName = TypeName(colBpcaCtrlGrp(Index))
        End If
        If (strTypeName = "OptionButton") Then
            Set ItmOpt = colBpcaCtrlGrp(Index)
        Else
            Set ItmOpt = Nothing
        End If
    Else
        Set ItmOpt = Nothing
    End If
End Property

Public Property Get ItmTgl(ByVal Index As Integer) As MSForms.ToggleButton
Dim strTypeName As String
    If (blnRgst = True) And _
       (Index > 0) And (Index <= colBpcaCtrlGrp.Count) Then
        If (blnAllType = False) Then
            strTypeName = MyTypeName
        Else
            strTypeName = TypeName(colBpcaCtrlGrp(Index))
        End If
        If (strTypeName = "ToggleButton") Then
            Set ItmTgl = colBpcaCtrlGrp(Index)
        Else
            Set ItmTgl = Nothing
        End If
    Else
        Set ItmTgl = Nothing
    End If
End Property

Public Property Get ItmCbo(ByVal Index As Integer) As MSForms.ComboBox
Dim strTypeName As String
    If (blnRgst = True) And _
       (Index > 0) And (Index <= colBpcaCtrlGrp.Count) Then
        If (blnAllType = False) Then
            strTypeName = MyTypeName
        Else
            strTypeName = TypeName(colBpcaCtrlGrp(Index))
        End If
        If (strTypeName = "ComboBox") Then
            Set ItmCbo = colBpcaCtrlGrp(Index)
        Else
            Set ItmCbo = Nothing
        End If
    Else
        Set ItmCbo = Nothing
    End If
End Property

Public Property Get ItmSpn(ByVal Index As Integer) As MSForms.SpinButton
Dim strTypeName As String
    If (blnRgst = True) And _
       (Index > 0) And (Index <= colBpcaCtrlGrp.Count) Then
        If (blnAllType = False) Then
            strTypeName = MyTypeName
        Else
            strTypeName = TypeName(colBpcaCtrlGrp(Index))
        End If
        If (strTypeName = "SpinButton") Then
            Set ItmSpn = colBpcaCtrlGrp(Index)
        Else
            Set ItmSpn = Nothing
        End If
    Else
        Set ItmSpn = Nothing
    End If
End Property

'---( InitFColor property )----------------------------------------
Public Property Get InitFColor(ByVal Index As Integer) As Long
    If (blnRgst = True) And _
       (Index > 0) And (Index <= colBpcaCtrlGrp.Count) Then
        InitFColor = clsBpcaCtrlCh(Index).InitFColor
    Else
        InitFColor = -1
    End If
End Property

'---( InitBColor property )----------------------------------------
Public Property Get InitBColor(ByVal Index As Integer) As Long
    If (blnRgst = True) And _
       (Index > 0) And (Index <= colBpcaCtrlGrp.Count) Then
        InitBColor = clsBpcaCtrlCh(Index).InitBColor
    Else
        InitBColor = -1
    End If
End Property

'===================================================================
' Event excitation method to be called from clsBpcaCh
'===================================================================
'Because the name of "Exit event" and "Exit statement" collide,
'I add "On" to the head of the name of the Enter/Exit event.

Friend Sub RaiseEnter(ByVal Index As Integer)
    RaiseEvent OnEnter(Index)
End Sub
  
Friend Sub RaiseExit(ByVal Index As Integer, ByVal Cancel As MSForms.ReturnBoolean)
    RaiseEvent OnExit(Index, Cancel)
End Sub
  
Friend Sub RaiseAfterUpdate(ByVal Index As Integer)
    RaiseEvent AfterUpdate(Index)
End Sub
  
Friend Sub RaiseBeforeUpdate(ByVal Index As Integer, ByVal Cancel As MSForms.ReturnBoolean)
    RaiseEvent BeforeUpdate(Index, Cancel)
End Sub

Friend Sub RaiseChange(ByVal Index As Integer)
    RaiseEvent Change(Index)
End Sub

Friend Sub RaiseClick(ByVal Index As Integer)
    RaiseEvent Click(Index)
End Sub

Friend Sub RaiseDblClick(ByVal Index As Integer, _
                         ByVal Cancel As MSForms.ReturnBoolean)
    RaiseEvent DblClick(Index, Cancel)
End Sub

Friend Sub RaiseKeyDown(ByVal Index As Integer, _
                        ByVal KeyCode As MSForms.ReturnInteger, _
                        ByVal Shift As Integer)
    RaiseEvent KeyDown(Index, KeyCode, Shift)
End Sub

Friend Sub RaiseKeyPress(ByVal Index As Integer, _
                         ByVal KeyAscii As MSForms.ReturnInteger)
    RaiseEvent KeyPress(Index, KeyAscii)
End Sub

Friend Sub RaiseKeyUp(ByVal Index As Integer, _
                      ByVal KeyCode As MSForms.ReturnInteger, _
                      ByVal Shift As Integer)
    RaiseEvent KeyUp(Index, KeyCode, Shift)
End Sub

Friend Sub RaiseMouseMove(ByVal Index As Integer, _
                          ByVal Button As Integer, _
                          ByVal Shift As Integer, _
                          ByVal X As Single, _
                          ByVal Y As Single)
    RaiseEvent MouseMove(Index, Button, Shift, X, Y)
End Sub

Friend Sub RaiseMouseDown(ByVal Index As Integer, _
                          ByVal Button As Integer, _
                          ByVal Shift As Integer, _
                          ByVal X As Single, _
                          ByVal Y As Single)
    RaiseEvent MouseDown(Index, Button, Shift, X, Y)
End Sub

Friend Sub RaiseMouseUp(ByVal Index As Integer, _
                        ByVal Button As Integer, _
                        ByVal Shift As Integer, _
                        ByVal X As Single, _
                        ByVal Y As Single)
    RaiseEvent MouseUp(Index, Button, Shift, X, Y)
End Sub

Friend Sub RaiseDropButtonClick(ByVal Index As Integer)
    RaiseEvent DropButtonClick(Index)
End Sub

Friend Sub RaiseSpinDown(ByVal Index As Integer)
    RaiseEvent SpinDown(Index)
End Sub

Friend Sub RaiseSpinUp(ByVal Index As Integer)
    RaiseEvent SpinUp(Index)
End Sub


'By MultiPage(Change),
'it fire FakeExit event of ActiveControl in the container control.
'OldPage: Previous page number of Page_Change event.
Friend Sub Change4FakeExit(ByVal Index As Integer, ByVal OldPage As Integer)
Dim Index2 As Integer
Dim ContainerMlt As MSForms.MultiPage
Dim ActCtrl As Object

    Set ContainerMlt = colBpcaContainerGrp(Index)
    
    On Error Resume Next
    Set ActCtrl = ContainerMlt.Pages(OldPage).ActiveControl
    On Error GoTo 0
    
    If Not (ActCtrl Is Nothing) Then
        Index2 = Me.getIndex(ActCtrl.Name)
        If (Index2 <> -1) Then
            RaiseEvent FakeExit(Index2)
        End If
    End If
    
    Set ContainerMlt = Nothing
    Set ActCtrl = Nothing
End Sub

'By Frame/MultiPage(Exit),
'it fire FakeExit event of ActiveControl in the container control.
Friend Sub Exit4FakeExit(ByVal Index As Integer)
Dim Index2 As Integer
Dim ContainerMlt As MSForms.MultiPage
Dim ContainerFra As MSForms.Frame
Dim ActCtrl As Object
    
    Select Case TypeName(colBpcaContainerGrp(Index))
      Case "MultiPage"
        Set ContainerMlt = colBpcaContainerGrp(Index)
        On Error Resume Next
        Set ActCtrl = ContainerMlt.Pages(ContainerMlt.Value).ActiveControl
        On Error GoTo 0
      Case "Frame"
        Set ContainerFra = colBpcaContainerGrp(Index)
        On Error Resume Next
        Set ActCtrl = ContainerFra.ActiveControl
        On Error GoTo 0
    End Select
    
    If Not (ActCtrl Is Nothing) Then
        Index2 = Me.getIndex(ActCtrl.Name)
        If (Index2 <> -1) Then
            RaiseEvent FakeExit(Index2)
        End If
    End If
    
    Set ContainerMlt = Nothing
    Set ContainerFra = Nothing
    Set ActCtrl = Nothing
End Sub


